#ifndef SYSTEMC_H
#include <systemc.h>
#define SYSTEMC_H
#endif

#ifndef COMPTEUR_H
#include "compteur.h"
#define COMPTEUR_H
#endif

#ifndef DISPLAY_H
#include "display.h"
#define DISPLAY_H
#endif
	
#define DESIGN "compteur" // le nom du design, celui a lancer par le script
			 //  ex : run compteur
	
int main (int argc , char *argv[]) {

sc_clock CLK("CLK",5); 
sc_signal<bool> RESET;
sc_signal<bool> UP;
sc_signal<bool> LOAD;
sc_signal<sc_uint<4> > VAL;  
sc_signal<sc_uint<4> > OUT; 

compteur CPT("Compteur");
CPT<<RESET<<CLK<<UP<<LOAD<<VAL<<OUT;

DISPLAY D("Affichage flux");
D<<RESET<<CLK<<UP<<LOAD<<VAL<<OUT;

sc_trace_file *CPT_trace;
CPT_trace = sc_create_wif_trace_file(DESIGN);

sc_trace(CPT_trace,CLK,"clk");

sc_trace(CPT_trace,RESET,"Reset");
sc_trace(CPT_trace,UP,"Up");
sc_trace(CPT_trace,LOAD,"Load");
sc_trace(CPT_trace,VAL,"Val");
sc_trace(CPT_trace,OUT,"Out");

sc_initialize();

VAL=9;
RESET=1;
UP=1;
LOAD=0;
sc_start(30);
RESET=0;
LOAD=1;
sc_start(10);
LOAD=0;
sc_start(10);
UP=0;
sc_start(40);
RESET=1;
sc_start(50);

sc_close_wif_trace_file(CPT_trace);
return 0;
}
