     library IEEE;
     use IEEE.STD_LOGIC_1164.ALL;
     library compteur_lib; 
     use compteur_lib.all;
            
     entity bench_compteur is         -- entity du BenchMark
     end bench_compteur;

     architecture comportementale of bench_compteur is

     component compteur 
       port (  reset : in Std_Logic; 
               clk   : in Std_Logic;
               up    : in Std_Logic;
               load  : in Std_Logic;
               val   : in std_logic_vector (3 downto 0);
               count : out std_logic_vector (3 downto 0);
     end component;

     signal clk_cpt : std_logic:= '0';
     signal reset_cpt: std_logic:= '1';
     signal up_cpt  : std_logic:= '1';
     signal load_cpt: std_logic:= '0';
     signal val_cpt : std_logic_vector (3 downto 0) := "1001";
     signal count_cpt : std_logic_vector (3 downto 0);

     begin

       cpt: compteur port map (reset_cpt, clk_cpt, up_cpt, load_cpt,
                                val_cpt, count_cpt);


       GENERATE_CLOCK : process  -- Process qui genere la clock
          begin
            clk_cpt<= '0';
            WAIT FOR 5 ns;
            clk_cpt<= '1';
            WAIT FOR 5 ns;
       end process GENERATE_CLOCK;

       CPT_SIM : process  -- Process qui genere les signaux d'entree                        
          begin
            reset_cpt<= '1';
            up_cpt<= '1';
            load_cpt<= '0'; 
            WAIT FOR 30 ns;
            reset_cpt<= '0';
            load_cpt<= '1';
            WAIT FOR 10 ns;
            load_cpt<= '0';
            WAIT FOR 10 ns;
            up_cpt<= '0';
            WAIT FOR 40 ns;
            reset_cpt<= '1';
            wait;
       end process CPT_SIM;

     end comportementale;
     
     
configuration compteur_cfg of bench_compteur is

    for comportementale
        for cpt:compteur
            use entity work.compteur(comportementale);
        end for;
    end for;

end compteur_cfg;
